/*!
  SerializeJSON jQuery plugin.
  https://github.com/marioizquierdo/jquery.serializeJSON
  version 3.1.1 (Nov, 2020)

  Copyright (c) 2012-2020 Mario Izquierdo
  Dual licensed under the MIT (http://www.opensource.org/licenses/mit-license.php)
  and GPL (http://www.opensource.org/licenses/gpl-license.php) licenses.
*/
!function(e){if("function"==typeof define&&define.amd)define(["jquery"],e);else if("object"==typeof exports){var n=require("jquery");module.exports=e(n)}else e(window.jQuery||window.Zepto||window.$)}(function(e){"use strict";e.fn.serializeJSON=function(n){var r=e.serializeJSON,t=this,i=r.setupOpts(n),a=e.extend({},i.defaultTypes,i.customTypes),u=t.serializeArray();r.readCheckboxUncheckedValues(u,i,t);var s={};return e.each(u,function(e,n){var u=n.name,l=n.value,o=u,f=r.attrFromInputWithName(t,u,"data-value-type");if(!f&&!i.disableColonTypes){var p=r.splitType(u);o=p[0],f=p[1]}if("skip"!==f){f||(f=i.defaultType);var d=r.applyTypeFunc(u,l,f,a);if(d||!r.shouldSkipFalsy(t,u,o,f,i)){var c=r.splitInputNameIntoKeysArray(o);r.deepSet(s,c,d,i)}}}),s},e.serializeJSON={defaultOptions:{},defaultBaseOptions:{checkboxUncheckedValue:void 0,useIntKeysAsArrayIndex:!1,skipFalsyValuesForTypes:[],skipFalsyValuesForFields:[],disableColonTypes:!1,customTypes:{},defaultTypes:{string:function(e){return String(e)},number:function(e){return Number(e)},boolean:function(e){return-1===["false","null","undefined","","0"].indexOf(e)},null:function(e){return-1===["false","null","undefined","","0"].indexOf(e)?e:null},array:function(e){return JSON.parse(e)},object:function(e){return JSON.parse(e)},skip:null},defaultType:"string"},setupOpts:function(n){null==n&&(n={});var r=e.serializeJSON,t=["checkboxUncheckedValue","useIntKeysAsArrayIndex","skipFalsyValuesForTypes","skipFalsyValuesForFields","disableColonTypes","customTypes","defaultTypes","defaultType"];for(var i in n)if(-1===t.indexOf(i))throw new Error("serializeJSON ERROR: invalid option '"+i+"'. Please use one of "+t.join(", "));return e.extend({},r.defaultBaseOptions,r.defaultOptions,n)},applyTypeFunc:function(e,r,t,i){var a=i[t];if(!a)throw new Error("serializeJSON ERROR: Invalid type "+t+" found in input name '"+e+"', please use one of "+n(i).join(", "));return a(r)},readCheckboxUncheckedValues:function(n,r,t){null==r&&(r={});var i="input[type=checkbox][name]:not(:checked):not([disabled])";t.find(i).add(t.filter(i)).each(function(t,i){var a=e(i).attr("data-unchecked-value");if(null==a&&(a=r.checkboxUncheckedValue),null!=a){if(i.name&&-1!==i.name.indexOf("[]["))throw new Error("serializeJSON ERROR: checkbox unchecked values are not supported on nested arrays of objects like '"+i.name+"'. See https://github.com/marioizquierdo/jquery.serializeJSON/issues/67");n.push({name:i.name,value:a})}})},splitType:function(e){var n=e.split(":");if(n.length>1){var r=n.pop();return[n.join(":"),r]}return[e,""]},shouldSkipFalsy:function(n,r,t,i,a){var u=e.serializeJSON.attrFromInputWithName(n,r,"data-skip-falsy");if(null!=u)return"false"!==u;var s=a.skipFalsyValuesForFields;if(s&&(-1!==s.indexOf(t)||-1!==s.indexOf(r)))return!0;var l=a.skipFalsyValuesForTypes;return null==i&&(i="string"),!(!l||-1===l.indexOf(i))},attrFromInputWithName:function(e,n,r){var t='[name="'+n.replace(/(:|\.|\[|\]|\s)/g,"\\$1")+'"]';return e.find(t).add(e.filter(t)).attr(r)},splitInputNameIntoKeysArray:function(n){var r=n.split("[");return""===(r=e.map(r,function(e){return e.replace(/\]/g,"")}))[0]&&r.shift(),r},deepSet:function(n,a,u,s){null==s&&(s={});var l=e.serializeJSON;if(t(n))throw new Error("ArgumentError: param 'o' expected to be an object or array, found undefined");if(!a||0===a.length)throw new Error("ArgumentError: param 'keys' expected to be an array with least one element");var o=a[0];if(1!==a.length){var f=a[1],p=a.slice(1);if(""===o){var d=n.length-1,c=n[d];o=r(c)&&t(l.deepGet(c,p))?d:d+1}""===f?!t(n[o])&&e.isArray(n[o])||(n[o]=[]):s.useIntKeysAsArrayIndex&&i(f)?!t(n[o])&&e.isArray(n[o])||(n[o]=[]):!t(n[o])&&r(n[o])||(n[o]={}),l.deepSet(n[o],p,u,s)}else""===o?n.push(u):n[o]=u},deepGet:function(n,i){var a=e.serializeJSON;if(t(n)||t(i)||0===i.length||!r(n)&&!e.isArray(n))return n;var u=i[0];if(""!==u){if(1===i.length)return n[u];var s=i.slice(1);return a.deepGet(n[u],s)}}};var n=function(e){if(Object.keys)return Object.keys(e);var n,r=[];for(n in e)r.push(n);return r},r=function(e){return e===Object(e)},t=function(e){return void 0===e},i=function(e){return/^[0-9]+$/.test(String(e))}});
